Payture = (function (Payture) {

  Payture.__internal__.model = (function (model) {
    var getDefaults = function () {
      return {
        PaymentData: '',
        CurrencyCode: 'RUB',
        GoogleEnvironment: 'TEST', // PRODUCTION  *в каком окружение используется*
        GoogleGatewayMerchantId: 'a4a6w4wzhq02i2i0pmpj1i37h8b1t4bja', // такой же прописывается в настройках терминала payture
        GoogleDisablePAN: false,
        Elements: {
          GoogleWebPayButton: document.getElementsByClassName('google-pay')[0],
          OverlayWait: document.getElementById('overlay-wait'),
          OverlayCvv: document.getElementById('overlay-cvv'),
          GoogleCvvButton: document.querySelectorAll("#overlay-cvv button.google")[0]||document.querySelectorAll("#overlay-cvv button")[0],
          GoogleCvv: document.getElementsByName('google-cvv')[0],
        },
        VisibilitySettings: {
          GoogleWebPayButton: false,
          OverlayWait: false,
          OverlayCvv: false,
          GoogleCvvButton: false,
          GoogleCvv: false
        },
        Data: {
          GoogleCvv: document.getElementsByName('google-cvv')[0],
        },
        FormValues: {
          GoogleCvv: '',
        },
        UsingFormValues: {
          GoogleCvv: false
        },
        DisableSettings: {
          GoogleCvvButton: false
        },
        LoadingButtons: {
          GoogleCvvButton: false
        }
      }
    }

    //google pay settings
    var allowedCardAuthMethods = ["PAN_ONLY", "CRYPTOGRAM_3DS"];   // любая карта или только токенизированная
    var baseRequest = {
        apiVersion: 2,
        apiVersionMinor: 0
      },
      allowedCardNetworks = ["AMEX", "JCB", "MASTERCARD", "VISA", "MIR"], // платежная система карты
      baseCardPaymentMethod = {
        type: 'CARD',
        parameters: {
          allowedAuthMethods: allowedCardAuthMethods,
          allowedCardNetworks: allowedCardNetworks
        },
      }
    
    var paymentsClient = null;

    var getGoogleTransactionInfo = function () {
      // цена берется из плейсхолдера, приходящего на шаблон (приходит в копейках, в интерфейсе гугл отображается в рублях)
      var amount = parseInt(document.getElementsByName('Amount')[0].value) / 100; 

      return {
        countryCode: 'RU',
        currencyCode: model.options.CurrencyCode,
        totalPriceStatus: 'FINAL',
        totalPrice: String(amount),
      }
    }

    var getGooglePaymentDataRequest = function () {
      return $ph.extend({}, baseRequest, {
        allowedPaymentMethods: [
          $ph.extend({}, baseCardPaymentMethod, {
            tokenizationSpecification: {
              type: 'PAYMENT_GATEWAY',
              parameters: {
                'gateway': 'payture', // выдан гуглом при регистрации
                'gatewayMerchantId': model.options.GoogleGatewayMerchantId  // такой же прописывается в настройках терминала payture
              }
            }
          })
        ],
        transactionInfo: getGoogleTransactionInfo(),
        merchantInfo: {
          merchantId: '11218867777662038582', // выдан гуглом при регистрации
          merchantName: 'Payture'
        }
      })
    }

    var getGooglePaymentsClient = function () {
      if (paymentsClient === null) {
        paymentsClient = new google.payments.api.PaymentsClient({
          environment: model.options.GoogleEnvironment
        });
      }
      return paymentsClient;
    }

    var getGoogleIsReadyToPayRequest = function () {
      return $ph.extend({}, baseRequest, {
        allowedPaymentMethods: [baseCardPaymentMethod]
      })
    }

    var prefetchGooglePaymentData = function () {
      var paymentDataRequest = getGooglePaymentDataRequest();
      paymentDataRequest.transactionInfo = {
        totalPriceStatus: 'NOT_CURRENTLY_KNOWN',
        currencyCode: 'RUB'
      };
      var paymentsClient = getGooglePaymentsClient();
      paymentsClient.prefetchPaymentData(paymentDataRequest);
    }

    function checkTypeGoogleToken() { // происходит проверка - токенизированная карта или нет
      var paymentData = model.options.PaymentData,
        data = paymentData.paymentMethodData.tokenizationData.token,
        b64string = window.btoa ? window.btoa(unescape(encodeURIComponent(data))) :
          base64.encode(unescape(encodeURIComponent(data)));

      $ph.ajax({
        url: '/apim/CheckTypeGoogleToken',
        data: $ph.getQuery({
          PayToken: b64string,
          Key: model.options.FormValues.Key
        }),
        type: 'POST',
        timeout: 60000,
        success: function (data) {
          switch (data.Type) {
            case 1: // карта нетокенизированная - показываем окно для ввода cvv
              model.options.UsingFormValues.GoogleCvv = true;
              model.setOption('VisibilitySettings.EmailVisibility', false);
              model.setOption('VisibilitySettings.CardOneBlock', false);
              model.setOption('VisibilitySettings.PayMethodsBlocks', false);            
              model.setOption('VisibilitySettings.PayButton', true);
              model.setOption('VisibilitySettings.OverlayCvv', true);
              model.setOption('VisibilitySettings.GoogleCvvButton', true);
              model.setOption('VisibilitySettings.GoogleCvv', true);
              break;
            case 2: // карта токенизированная - сразу производим оплату
              model.options.UsingFormValues.GoogleCvv = false;
              model.setOption('VisibilitySettings.OverlayWait', true);
              var promise = googleProcessPaymentAfterCVV();
              promise.then(function (response) {
                if (response.Success == true) {
                  model.onSuccess(response);
                } else {
                  model.onError(response);
                }
                model.setOption('VisibilitySettings.OverlayWait', false);
              });
              break;
            default:
              model.onError(data);
          }
        },
        error: function (data) {
          model.onError(data);
        }
      })
    }

    function googleProcessPaymentAfterCVV() {
      var options = model.options,
        paymentData = options.PaymentData,
        cvv = model.options.FormValues.GoogleCvv,
        data = paymentData.paymentMethodData.tokenizationData.token,
        b64string = window.btoa ? window.btoa(unescape(encodeURIComponent(data))) : // token от устройства кодируется в base64
          base64.encode(unescape(encodeURIComponent(data)));

      var cvvObj = {},
        amount = parseInt(document.getElementsByName('Amount')[0].value);

      if (cvv) {
        cvvObj = {
          SecureCode: cvv
        }
      }
      if(options.UsingFormValues.BrowserData) {
        cvvObj.BrowserData = options.FormValues.BrowserData;
      }
      
      var data = {
        Amount: amount, // стоимость в копейках
        Json: true,
        PayToken: b64string, // token полученный от устройства
        EChequeCustomerContact: options.FormValues.EChequeCustomerContact, // email для отправки чека (если был указан)
        Data: $ph.getDelimitedParams($ph.extend({
          Key: options.FormValues.Key // Key с шаблона
        }, cvvObj)) // cvv если оплата по нетокенизированной карте, иначе пустой
      };

      if (model.options.UsingFormValues.AuthId) {
        $ph.extend(data, {
          AuthId: model.options.FormValues.AuthId
        })
      }

      return new Promise(function(resolve, reject){
        $ph.ajax({
          url: model.options.ApiPath + '/PaySubmitMobile',
          data: $ph.getQuery(data),
          type: 'POST',
          timeout: 60000,
          success: function (res) {
            resolve(res);
          },
          error: function (res) {
            reject(res);
          }
        })
      })        
      

    }
    function googleProcessPaymentAfterCVVAndPreauth () {
        var promise = googleProcessPaymentAfterCVV();

        promise
          .then(function (response) {
            if (response.Success == true) {
              model.onSuccess(response);
            } else {
              model.onError(response);
            }
            setTimeout(function(){
              model.setOption('VisibilitySettings.OverlayCvv', false);
              model.setOption('VisibilitySettings.OverlayWait', false);
              model.setOption('LoadingButtons.GoogleCvvButton', false);
              model.setOption('VisibilitySettings.GoogleCvv', false);
              model.options.Data.GoogleCvv.value = '';
              model.options.FormValues.GoogleCvv = '';                     
            }, 1500)

          })
          .catch(function(response){
            model.setOption('VisibilitySettings.OverlayCvv', false);
            model.setOption('VisibilitySettings.OverlayWait', false);
            model.setOption('LoadingButtons.GoogleCvvButton', false);
            model.setOption('VisibilitySettings.GoogleCvv', false);
            model.options.Data.GoogleCvv.value = '';
            model.options.FormValues.GoogleCvv = '';
            model.onError(response);
          })
      }
    return $ph.extend(model, {
      googleWebPayInit: function () {
        view = Payture.__internal__.view;
        var options = Object.assign({}, model.options);
        model.options = model.createOptions( model.options, getDefaults(), options);
        if(model.options.GoogleDisablePAN) {
          allowedCardAuthMethods = ["CRYPTOGRAM_3DS"]; 
          baseCardPaymentMethod = {
            type: 'CARD',
            parameters: {
              allowedAuthMethods: allowedCardAuthMethods,
              allowedCardNetworks: allowedCardNetworks
            },
          };
        }        
        var paymentsClient = getGooglePaymentsClient();
        paymentsClient.isReadyToPay(getGoogleIsReadyToPayRequest()) // проверка - возможна ли оплата
          .then(function (response) {
            if (response.result) { // если возможна показываем кнопку для выбора этого метода оплаты
              console.log('GP isReadyToPay');
              model.setOption('VisibilitySettings.GoogleWebPayButton', true)
              prefetchGooglePaymentData();
            } else {
              console.log('GP isReadyToPay not allowed');
            }
          })
          .catch(function (err) {
            console.log(err);
          });
      },
      googleWebPay: function () { // вызывается при нажатии на кнопку "Оплатить" при выбраном методе GooglePay
        //model.setOption('LoadingButtons.PayButton', true);
        //model.setOption('DisableSettings.PayButton', true);

        var paymentDataRequest = getGooglePaymentDataRequest();
        paymentDataRequest.transactionInfo = getGoogleTransactionInfo();
        var paymentsClient = getGooglePaymentsClient();
        paymentsClient.loadPaymentData(paymentDataRequest)
          .then(function (paymentData) {
            // запоминается token переданный устройством для дальнейшего проведения платежа и проверки карты на токенизированность
            model.options.PaymentData = paymentData; 
            // проверка карты на токенизированность
            checkTypeGoogleToken();
          })
          .catch(function (err) {
            //model.setOption('LoadingButtons.PayButton', false);
            model.setOption('PaymentType', 'card_pay');
            view.checkButton();
            console.log('GP loadPaymentData fail');
            console.log(err);
          });
      },
      googleProcessPaymentWCVVAction: function () { // вызывается при оплате нетокенизированной картой после потдтверждения ввода CVV
        model.setOption('VisibilitySettings.OverlayWait', true);
        
        if(model.options.use_3ds2_preauth && model.options.use_3ds2) {
          model.preAuth(googleProcessPaymentAfterCVVAndPreauth, ['PayToken'])
        } else {
          googleProcessPaymentAfterCVVAndPreauth()
        }
      }
    })
  })(Payture.__internal__.model)


  Payture.__internal__.view = (function (view) {
    var model = null,
      options = null,
      elements = null;

    var setPageEventHandlers = function () {
      $ph.addEvent('click', elements.GoogleCvvButton, function (event) {
        if(model.options.FormValues.GoogleCvv.length >= 3) {
          model.setOption('LoadingButtons.GoogleCvvButton', true);

          model.googleProcessPaymentWCVVAction();          
        }
      })
    }

    var setListeners = function () {
      model.addListener('VisibilitySettings.OverlayCvv', function (fieldName, fieldNewValue) {
        if (fieldNewValue) {
          model.setOption('VisibilitySettings.PayButton', false);
          model.setOption('VisibilitySettings.EMailBlock', false);
          setTimeout(function(){
            options.Data.GoogleCvv.focus();
          }, 500)
        } else {
          model.setOption('VisibilitySettings.EmailVisibility', true);
          model.setOption('VisibilitySettings.CardOneBlock', true);
          model.setOption('VisibilitySettings.PayMethodsBlocks', true);            

          model.setOption('VisibilitySettings.PayButton', true);
          //model.setOption('VisibilitySettings.EMailBlock', true);
        }
      })
    }

    return $ph.extend(view, {
      googleWebPayInit: function () {
        model = Payture.__internal__.model;
        options = model.options;
        elements = options.Elements;

        setPageEventHandlers();
        setListeners();
      }
    })
  })(Payture.__internal__.view)

  return $ph.extend(Payture, {
    GoogleWebPay: function () {
      this.__internal__.model.googleWebPayInit();
      this.__internal__.view.googleWebPayInit();
    }
  })

})(Payture)